unit hiUseActiveXEx;

interface

uses
  Windows,Kol,Win,Share,{ActiveKOL,}KOLComObj,objects,
  ActiveX,err,Messages;

type
  THIUseActiveXEx = class(THIWin)
   private
     FActiveX:IDispatch;
     u:IUnknown;
     FHWndControl,FHWndTmp: HWND; // Handle ActiveX 
     OldWind: longint;
     NewWind: longint;

     procedure NewWndProc(var Msg: TMessage);
     procedure SetHook;
     function _OnMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; override;

   public
    _event_onCreate: THI_Event;

    _prop_IsGUI: boolean;
    _prop_CLASS: string;
    _prop_IID: string;
    _prop_FileName:string;
    _prop_LicKeys:string;
    constructor Create(Parent:PControl);
    destructor Destroy; override;
    procedure Init; override;
    procedure Load;
    procedure _var_Dispatch(var _Data:TData; Index:word);
  end;

  function AtlAxWinInit:BOOL;stdcall;
  function AtlAxAttachControl(unk:IUnknown;Handle:HWND;out ppUnkContainer:IUnknown):HResult;stdcall;

implementation

//uses DebugEx;

const
  NULL_GUID: TGUID = '{00000000-0000-0000-0000-000000000000}';
  IID_IDispatch: TGUID = '{00020400-0000-0000-C000-000000000046}';
  atl_library = 'atl.dll';
  function AtlAxWinInit; external atl_library name 'AtlAxWinInit';
  function AtlAxAttachControl; external atl_library name 'AtlAxAttachControl';


var
  DllHandle:THandle;

{ THIUseActiveXEx }
constructor THIUseActiveXEx.Create;
begin
  inherited Create(Parent);
  //    ActiveX
  //Control := _NewControl(FParent,'TActiveXControl', WS_CHILD or WS_VISIBLE or WS_TABSTOP,False,nil);
  Control := NewButton(FParent,'');
  InitAdd(Load);
end;

destructor THIUseActiveXEx.Destroy;
begin
   SetWindowLong(FHWndControl, GWL_WNDPROC, OldWind);
   FreeObjectInstance(Pointer(NewWind));
   inherited;
end;

procedure THIUseActiveXEx.Load;
begin
  _hi_onEvent(_event_onCreate);
end;


function THIUseActiveXEx._OnMessage;
begin
  case Msg.message of
    //      ActiveX 
    WM_SETFOCUS:
      begin
        Windows.SetFocus(FHWndControl);
        Exit;
      end;
  end;
  Result := Inherited _OnMessage(Msg,Rslt);
end;


procedure THIUseActiveXEx.Init;
var
  CF:IClassFactory2;
  AXControlObj:TDllGetClassObject;
  Err: HResult;
  fn:string;
begin
  //   
  fn := _prop_FileName;
  try
  //   ActiveX  
   if FileExists(fn) then
      DllHandle := LoadLibrary(PChar(fn))
      //DllHandle := CoLoadLibrary(PWideChar(fn), True)
   // !!!     ActiveX   
   else begin
     _Debug(' ' + fn + ' ActiveX   ');
     Halt;
   end;

  if _prop_IsGUI then
  begin
    //  
    Control.Color := FParent.Color;
    with Control{$ifndef F_P}^{$endif} do
    begin
      SetPosition(_prop_Left,_prop_Top);
      SetSize(_prop_Width,_prop_Height);
      Enabled := _prop_Enabled;
      Visible := _prop_Visible;
    end;
  end;

  //  
  AXControlObj := GetProcAddress(DllHandle,'DllGetClassObject');
  AXControlObj(StringToGuid(_prop_CLASS),IClassFactory2,CF);
  //   
  if _prop_LicKeys <> '' then
    Err := CF.CreateInstanceLic(nil,nil,StringToGuid(_prop_IID), WideString(_prop_LicKeys),FActiveX)
  else
    Err := CF.CreateInstance(nil,StringToGuid(_prop_IID), FActiveX);
  case Err of
    S_OK:;// _Msg('S_OK');
    E_NOINTERFACE:;// _Msg('E_NOINTERFACE');
    CLASS_E_CLASSNOTAVAILABLE:;// _Msg('CLASS_E_CLASSNOTAVAILABLE');
  end;

  except
    on E:Exception do
    begin
      Control := NewLabel(FParent, E.Message);
      Control.Color := $FFFFFF;
      Control.Font.Color := $FF;
    end;
  end;

  inherited Init;

  if _prop_IsGUI then
  begin
    //    
    AtlAxAttachControl(FActiveX, Control.Handle, u);

    //   Handle ActiveX 
    // !!!     WS_TABSTOP
    FHWndTmp := 0;
    FHWndControl := GetWindow(Control.Handle,gw_Child);
    repeat
      FHWndTmp := GetWindow(FHWndControl,gw_Child);
      if FHWndTmp = 0 then break;
      FHWndControl := GetWindow(FHWndControl,gw_Child);
    until FHWndTmp <> 0;

    //        Handle
    if FHWndControl <> 0 then SetHook;
  end else Control.Visible := False;
end;


//  ActiveX    Tab
procedure THIUseActiveXEx.NewWndProc;
var m,w,l:LongInt;
begin
  m := Msg.Msg;
  w := Msg.WParam;
  l := Msg.LParam;
  //   Tab   
  if m = WM_KEYDOWN then
     if w = VK_TAB then
  //   
  Windows.SetFocus(0);

  case m of
    WM_LBUTTONDOWN:
      begin
        //     
        //    Tab()
        Control.Focused := True;
      end;
    WM_KILLFOCUS:
      begin
        if GetKeyState( VK_TAB ) < 0 then
          Control.GotoControl(VK_TAB);
      end;

    //      
    WM_SIZE:
      begin
        SetWindowPos(FHWndControl,0,0,0,Control.Width,
          Control.Height,SWP_NOMOVE or SWP_NOZORDER);
      end;

  end; // end case
  //   
  SendMessage(Control.Handle, m, w,l);
  Msg.Result := CallWindowProc(Pointer(OldWind), FHWndControl, Msg.Msg, Msg.wParam, Msg.lParam);
end;

//      ActiveX
procedure THIUseActiveXEx.SetHook;
begin
   OldWind := GetWindowLong(FHWndControl, GWL_WNDPROC);
   NewWind := LongInt(MakeObjectInstance(NewWndProc));
   SetWindowLong(FHWndControl, GWL_WNDPROC, NewWind);
   Control.OnMessage := _OnMessage;
end;

procedure THIUseActiveXEx._var_Dispatch;
const data_disp = 30;
var
  dt: TData;
begin
  dtNull(dt);
  if Assigned(FActiveX)then
  begin
    dt.data_type := data_disp;
    dt.idata := Cardinal(Pointer(FActiveX));
    dtData(_Data, dt);
  end;
end;

initialization
  CoInitialize(nil);

finalization
  CoFreeUnusedLibraries();
  CoUninitialize();

end.
